<span id="further" class="anchor"></span>

APPENDIX A
----------
Conclusion and Further Reading
==============================
The book is over but your learning is just starting. This appendix provides the book's conclusion, lists of JavaScript blog posts, articles, e-books, books, and other resources.

Conclusion
----------

We hope you've enjoyed this book. It was intended to be small on theory
but big on practice and give you an overview of multiple technologies,
frameworks, and techniques used in modern agile web development. Full
Stack JavaScript touched topics such as the following:

-   jQuery, JSON, and AJAX/XHR

-   Bootstrap, CSS, and Less

-   Backbone.js, AMD, and Require.js

-   Node.js, REST API, and Parse.com

-   MongoDB and BSON

-   AWS, Heroku, and MongoLab

If you need in-depth knowledge or references, scroll down to the list of
suggested reading or do a Google search.

Practical aspects included building multiple versions of the Message
Board app:

-   jQuery + Parse.com JS REST API

-   Backbone and Parse.com JS SDK

-   Backbone and Node.js

-   Backbone and Node.js + MongoDB

The Message Board application has all the foundation of a typical
web/mobile application: fetching data, displaying it, submitting new
data. Other examples include:

-   jQuery + OpenWeatherMap RESP API

-   Parse.com "Save John"

-   Node.js "Hello World"

-   MongoDB "Print Collections"

-   Backbone.js "Hello World"

-   Backbone.js "Apple Database"

Please submit a GitHub issue if you have any feedback; comments;
suggestions; or you've found typos, bugs, mistakes, or other errata:
<https://github.com/azat-co/fullstack-javascript/issues>.

Other ways to connect are via: @azatmardan (http://twitter.com/azatmardan),
<http://webapplog.com>, <http://azat.co>.

In case you enjoyed Node.js and want to find out more about building
production web services with Express.js—a de facto standard for Node.js
web apps—take a look at my book [Pro
Express.js](http://proexpressjs.com).

Further Reading
---------------

Here is a list of resources, courses, books, and blogs for further
reading.

### Free JavaScript and Node.js Resources

-   [Node University Blog](https://node.university/blog) (https://node.university/blog)
-   [ES6 Cheatsheet](https://gumroad.com/l/LDwVU/git-1CC81D40) (https://gumroad.com/l/LDwVU/git-1CC81D40)
-   [MongoDB and Mongoose Cheatsheet](https://gum.co/mongodb/git-874e6fb4) (https://gumroad.com/l/mongodb/git-874e6fb4)
-   [Express.js 4 Cheatsheet](https://gum.co/NQiQ/git-874E6FB4) (https://gumroad.com/l/NQiQ/git-874E6FB4)
-   [React Cheatsheet](https://gum.co/IJRtw/git-FB2C5E22) (https://gumroad.com/l/IJRtw/git-FB2C5E22)
-   [JavaScript For Cats](http://jsforcats.com/) (http://jsforcats.com/): an introduction for new programmers
-   [Superhero.js](http://superherojs.com/) (http://superherojs.com/): comprehensive collection of JS resources
-   [JavaScript Guide](https://developer.mozilla.org/en-US/docs/JavaScript/Guide) (https://developer.mozilla.org/en-US/docs/Web/JavaScript/Guide) by Mozilla Developer Network
-   [JavaScript Reference](https://developer.mozilla.org/en-US/docs/JavaScript/Reference) (https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference) by Mozilla Developer Network
-   [Felix's Node.js Style Guide](https://github.com/felixge/node-style-guide) (https://github.com/felixge/node-style-guide)


### Good JavaScript Books

-   [React Quickly: Painless web apps with React, JSX, Redux, and GraphQL](https://www.amazon.com/React-Quickly-Painless-Redux-GraphQL/dp/1617293342) (<https://amzn.to/2MV6pKG>)
-   [JavaScript: The Good Parts](http://shop.oreilly.com/product/9780596517748.do) (http://shop.oreilly.com/product/9780596517748.do)
-   [JavaScript: The Definitive Guide](http://www.amazon.com/dp/0596101996/?tag=stackoverfl08-20) (http://www.amazon.com/dp/0596101996/?tag=stackoverfl08-20)
-   [Secrets of the JavaScript Ninja](http://www.manning.com/resig/)(http://www.manning.com/resig/)
-   [Pro JavaScript Techniques](http://www.amazon.com/dp/1590597273/?tag=stackoverfl08-20)(http://www.amazon.com/dp/1590597273/?tag=stackoverfl08-20)
-   [Eloquent JavaScript](http://eloquentjavascript.net/) (http://eloquentjavascript.net/): a modern introduction to programming

### Good Node.js Books

-   [Pro Express.js](http://proexpressjs.com) (http://proexpressjs.com)
-   [Practical Node.js](https://github.com/azat-co/practicalnode) (https://github.com/azat-co/practicalnode)
-   [Node.js in Action](http://www.manning.com/cantelon) (http://www.manning.com/cantelon)
-   [Deep Express.js API Reference](http://amzn.to/1xcHanf) (http://amzn.to/1xcHanf)

### Interactive Online Classes and Courses

-   [Node University](https://node.university) (https://node.university)
-   [Introduction to NodeJS on edX](https://www.edx.org/course/introduction-to-nodejs-0) (https://www.edx.org/course/introduction-to-nodejs-0)

### Startup Books and Blogs

-   [Hackers & Painters](http://www.amazon.com/Hackers-Painters-Big-Ideas-Computer/dp/1449389554) (http://www.amazon.com/Hackers-Painters-Big-Ideas-Computer/dp/1449389554)
-   [The Lean Startup](http://theleanstartup.com/book) (http://theleanstartup.com/book)
-   [The Startup Owner's Manual](http://www.amazon.com/Startup-Owners-Manual-Step-Step/dp/0984999302) (http://www.amazon.com/Startup-Owners-Manual-Step-Step/dp/0984999302)
-   [The Entrepreneur's Guide to Customer Development](http://www.amazon.com/The-Entrepreneurs-Guide-Customer-Development/dp/0982743602/) (http://www.amazon.com/The-Entrepreneurs-Guide-Customer-Development/dp/0982743602)
-   [Venture Hacks](http://venturehacks.com/) (http://venturehacks.com)
-   [Webapplog](http://webapplog.com) (http://webapplog.com)
